/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.27 Revision 1.260
1# Copyright 1999-2004 Gentoo Technologies, Inc. 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.27 2004/02/15 20:11:00 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.260 2011/08/29 01:28:10 vapier Exp $
4 4
5# kernel.eclass rewrite for a clean base regarding the 2.6 series of kernel 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Author: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Copyright 2004 Gentoo Linux 9# Maintainer: kernel-misc@gentoo.org
10# 10#
11# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
12# thatll be: johnm
13 12
14# added functionality: 13# added functionality:
15# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
16 15
17# A Couple of env vars are available to effect usage of this eclass 16# A Couple of env vars are available to effect usage of this eclass
18# These are as follows: 17# These are as follows:
19# 18#
19# K_USEPV - When setting the EXTRAVERSION variable, it should
20# add PV to the end.
21# this is useful for thigns like wolk. IE:
22# EXTRAVERSION would be something like : -wolk-4.19-r1
20# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be automatically set within the kernel Makefile 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24# automatically set within the kernel Makefile
21# K_NOUSENAME - if this is set then EXTRAVERSION will not include the first part of ${PN} in EXTRAVERSION 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
22# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, ck-sources, ac-sources) it will use PR (ie: -r5) as the patchset version for 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
30# ck-sources, ac-sources) it will use PR (ie: -r5) as
31# the patchset version for
23# - and not use it as a true package revision 32# and not use it as a true package revision
24# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in postinst and can be used to carry additional postinst messages 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
34# postinst and can be used to carry additional postinst
35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
25# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
26 38# K_SYMLINK - if this is set, then forcably create symlink anyway
39#
40# K_DEFCONFIG - Allow specifying a different defconfig target.
41# If length zero, defaults to "defconfig".
42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43# combination of "base" and "extras"
44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
45# A value of "5" would apply genpatches-2.6.12-5 to
46# my-sources-2.6.12.ebuild
47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
48# K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
49# code. If empty, will be set to "1" if deblobbing is
50# possible. Test ONLY for "1".
51# K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
52# If false, either optional deblobbing will be available
53# or the license will note the inclusion of freedist
54# code.
55# K_LONGTERM - If set, the eclass will search for the kernel source
56# in the long term directories on the upstream servers
57# as the location has been changed by upstream
27# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which can be supported by the headers ebuild 58# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
59# can be supported by the headers ebuild
28 60
29# UNIPATCH_LIST - space delimetered list of patches to be applied to the kernel 61# UNIPATCH_LIST - space delimetered list of patches to be applied to the
62# kernel
30# UNIPATCH_EXCLUDE - an addition var to support exlusion based completely on "<passedstring>*" and not "<passedno#>_*" 63# UNIPATCH_EXCLUDE - an addition var to support exlusion based completely
31# - this should _NOT_ be used from the ebuild as this is reserved for end users passing excludes from the cli 64# on "<passedstring>*" and not "<passedno#>_*"
65# - this should _NOT_ be used from the ebuild as this is
66# reserved for end users passing excludes from the cli
32# UNIPATCH_DOCS - space delimemeted list of docs to be installed to the doc dir 67# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
68# the doc dir
33# UNIPATCH_STRICTORDER - if this is set places patches into directories of order, so they are applied in the order passed 69# UNIPATCH_STRICTORDER - if this is set places patches into directories of
70# order, so they are applied in the order passed
34 71
35ECLASS="kernel-2" 72inherit eutils toolchain-funcs versionator multilib
36EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst 73EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm
37 74
75# Added by Daniel Ostrow <dostrow@gentoo.org>
76# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
77# I will remove it when I come up with something more reasonable.
78[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
79
80export CTARGET=${CTARGET:-${CHOST}}
81if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
82 export CTARGET=${CATEGORY/cross-}
83fi
84
38HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 85HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
86[[ -z ${LICENSE} ]] && \
39LICENSE="GPL-2" 87 LICENSE="GPL-2"
40IUSE="${IUSE} build"
41SLOT="${KV}"
42 88
43# Grab kernel version from KV 89# This is the latest KV_PATCH of the deblob tool available from the
44KV_MAJOR=$(echo ${KV} | cut -d. -f1) 90# libre-sources upstream. If you bump this, you MUST regenerate the Manifests
45KV_MINOR=$(echo ${KV} | cut -d. -f2) 91# for ALL kernel-2 consumer packages where deblob is available.
46KV_PATCH=$(echo ${KV} | cut -d. -f3) 92[[ -z ${DEBLOB_MAX_VERSION} ]] && DEBLOB_MAX_VERSION=38
47KV_PATCH=${KV_PATCH/[-_]*/} 93
94# No need to run scanelf/strip on kernel sources/headers (bug #134453).
95RESTRICT="binchecks strip"
48 96
49# set LINUX_HOSTCFLAGS if not already set 97# set LINUX_HOSTCFLAGS if not already set
98[[ -z ${LINUX_HOSTCFLAGS} ]] && \
50[ -z "$LINUX_HOSTCFLAGS" ] && LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 99 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
51 100
52 101# debugging functions
53#eclass functions only from here onwards.
54#============================================================== 102#==============================================================
103# this function exists only to help debug kernel-2.eclass
104# if you are adding new functionality in, put a call to it
105# at the start of src_unpack, or during SRC_URI/dep generation.
106debug-print-kernel2-variables() {
107 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
108 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
109 UNIPATCH_LIST S KERNEL_URI K_WANT_GENPATCHES ; do
110 debug-print "${v}: ${!v}"
111 done
112}
113
114#Eclass functions only from here onwards ...
115#==============================================================
116handle_genpatches() {
117 local tarball
118 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
119
120 debug-print "Inside handle_genpatches"
121 local oldifs=${IFS}
122 export IFS="."
123 local OKV_ARRAY=( $OKV )
124 export IFS=${oldifs}
125
126 # for > 3.0 kernels, handle genpatches tarball name
127 # genpatches for 3.0 and 3.0.1 might be named
128 # genpatches-3.0-1.base.tar.bz2 and genpatches-3.0-2.base.tar.bz2
129 # respectively. Handle this.
130
131 for i in ${K_WANT_GENPATCHES} ; do
132 if [[ ${KV_MAJOR} -ge 3 ]]; then
133 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
134 tarball="genpatches-${KV_MAJOR}.${KV_MINOR}-${K_GENPATCHES_VER}.${i}.tar.bz2"
135 else
136 tarball="genpatches-${KV_MAJOR}.${KV_PATCH}-${K_GENPATCHES_VER}.${i}.tar.bz2"
137 fi
138 else
139 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
140 fi
141 debug-print "genpatches tarball: $tarball"
142 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
143 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
144 done
145}
146
147detect_version() {
148 # this function will detect and set
149 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
150 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
151 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
152
153 if [[ -n ${KV_FULL} ]]; then
154 # we will set this for backwards compatibility.
155 KV=${KV_FULL}
156
157 # we know KV_FULL so lets stop here. but not without resetting S
158 S=${WORKDIR}/linux-${KV_FULL}
159 return
160 fi
161
162 # CKV is used as a comparison kernel version, which is used when
163 # PV doesnt reflect the genuine kernel version.
164 # this gets set to the portage style versioning. ie:
165 # CKV=2.6.11_rc4
166 CKV=${CKV:-${PV}}
167 OKV=${OKV:-${CKV}}
168 OKV=${OKV/_beta/-test}
169 OKV=${OKV/_rc/-rc}
170 OKV=${OKV/-r*}
171 OKV=${OKV/_p*}
172
173 KV_MAJOR=$(get_version_component_range 1 ${OKV})
174 # handle if OKV is X.Y or X.Y.Z (e.g. 3.0 or 3.0.1)
175 local oldifs=${IFS}
176 export IFS="."
177 local OKV_ARRAY=( $OKV )
178 export IFS=${oldifs}
179
180 # if KV_MAJOR >= 3, then we have no more KV_MINOR
181 #if [[ ${KV_MAJOR} -lt 3 ]]; then
182 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
183 KV_MINOR=$(get_version_component_range 2 ${OKV})
184 KV_PATCH=$(get_version_component_range 3 ${OKV})
185 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
186 KV_EXTRA=$(get_version_component_range 4- ${OKV})
187 KV_EXTRA=${KV_EXTRA/[-_]*}
188 else
189 KV_PATCH=$(get_version_component_range 3- ${OKV})
190 fi
191 else
192 KV_PATCH=$(get_version_component_range 2 ${OKV})
193 KV_EXTRA=$(get_version_component_range 3- ${OKV})
194 KV_EXTRA=${KV_EXTRA/[-_]*}
195 fi
196
197 debug-print "KV_EXTRA is ${KV_EXTRA}"
198
199 KV_PATCH=${KV_PATCH/[-_]*}
200
201 local v n=0 missing
202 #if [[ ${KV_MAJOR} -lt 3 ]]; then
203 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
204 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
205 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
206 done
207 else
208 for v in CKV OKV KV_{MAJOR,PATCH} ; do
209 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
210 done
211 fi
212
213 [[ $n -eq 1 ]] && \
214 eerror "Missing variables: ${missing}" && \
215 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
216 unset v n missing
217
218# if [[ ${KV_MAJOR} -ge 3 ]]; then
219 if [[ ${#OKV_ARRAY[@]} -lt 3 ]]; then
220 KV_PATCH_ARR=(${KV_PATCH//\./ })
221
222 # at this point 080811, Linus is putting 3.1 kernels in 3.0 directory
223 # revisit when 3.1 is released
224 if [[ ${KV_PATCH} -gt 0 ]]; then
225 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
226 else
227 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_PATCH_ARR}"
228 fi
229 # KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_PATCH_ARR}"
230 [[ -n "${K_LONGTERM}" ]] &&
231 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_PATCH_ARR}"
232 else
233 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.0"
234 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
235 [[ -n "${K_LONGTERM}" ]] &&
236 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
237 fi
238
239 debug-print "KERNEL_BASE_URI is ${KERNEL_BASE_URI}"
240
241 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
242 # handle non genpatch using sources correctly
243 if [[ -z ${K_WANT_GENPATCHES} && -z ${K_GENPATCHES_VER} && ${KV_PATCH} -gt 0 ]]; then
244 KERNEL_URI="${KERNEL_BASE_URI}/patch-${OKV}.bz2"
245 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
246 fi
247 KERNEL_URI="${KERNEL_URI} ${KERNEL_BASE_URI}/linux-${KV_MAJOR}.${KV_MINOR}.tar.bz2"
248 else
249 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
250 fi
251
252 RELEASE=${CKV/${OKV}}
253 RELEASE=${RELEASE/_beta}
254 RELEASE=${RELEASE/_rc/-rc}
255 RELEASE=${RELEASE/_pre/-pre}
256 # We cannot trivally call kernel_is here, because it calls us to detect the
257 # version
258 #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
259 [ $(($KV_MAJOR * 1000 + ${KV_MINOR:-0})) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
260 RELEASETYPE=${RELEASE//[0-9]}
261
262 # Now we know that RELEASE is the -rc/-git
263 # and RELEASETYPE is the same but with its numerics stripped
264 # we can work on better sorting EXTRAVERSION.
265 # first of all, we add the release
266 EXTRAVERSION="${RELEASE}"
267 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
268 [[ -n ${KV_EXTRA} ]] && [[ ${KV_MAJOR} -lt 3 ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
269
270 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
271 if [[ -n "${K_NOUSEPR}" ]]; then
272 # Don't add anything based on PR to EXTRAVERSION
273 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
274 elif [[ -n ${K_PREPATCHED} ]]; then
275 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
276 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
277 elif [[ "${ETYPE}" = "sources" ]]; then
278 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
279 # For some sources we want to use the PV in the extra version
280 # This is because upstream releases with a completely different
281 # versioning scheme.
282 case ${PN/-*} in
283 wolk) K_USEPV=1;;
284 vserver) K_USEPV=1;;
285 esac
286
287 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
288 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
289 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
290 fi
291 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
292
293 # The only messing around which should actually effect this is for KV_EXTRA
294 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
295 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
296
297 if [[ -n ${KV_EXTRA} ]]; then
298 if [[ -n ${KV_MINOR} ]]; then
299 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
300 else
301 OKV="${KV_MAJOR}.${KV_PATCH}"
302 fi
303 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.bz2
304 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
305 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
306 fi
307
308 # We need to set this using OKV, but we need to set it before we do any
309 # messing around with OKV based on RELEASETYPE
310 KV_FULL=${OKV}${EXTRAVERSION}
311
312 # we will set this for backwards compatibility.
313 S=${WORKDIR}/linux-${KV_FULL}
314 KV=${KV_FULL}
315
316 # -rc-git pulls can be achieved by specifying CKV
317 # for example:
318 # CKV="2.6.11_rc3_pre2"
319 # will pull:
320 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
321
322 if [[ ${KV_MAJOR}${KV_MINOR} -eq 26 ]]; then
323
324 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
325 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
326 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.bz2
327 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
328 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
329 fi
330
331 if [[ ${RELEASETYPE} == -git ]]; then
332 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.bz2
333 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
334 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
335 fi
336
337 if [[ ${RELEASETYPE} == -rc-git ]]; then
338 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
339 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
340 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
341 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
342
343 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
344 fi
345 else
346 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
347 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
348 OKV="2.6.39"
349 else
350 KV_PATCH_ARR=(${KV_PATCH//\./ })
351 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
352 fi
353 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.bz2
354 ${KERNEL_BASE_URI}/testing/linux-${OKV}.tar.bz2"
355 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
356 fi
357
358 if [[ ${RELEASETYPE} == -git ]]; then
359 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.bz2
360 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
361 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
362 fi
363
364 if [[ ${RELEASETYPE} == -rc-git ]]; then
365 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
366 OKV="2.6.39"
367 else
368 KV_PATCH_ARR=(${KV_PATCH//\./ })
369 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
370 fi
371 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.bz2
372 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.bz2
373 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
374
375 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.bz2"
376 fi
377
378
379 fi
380
381
382 debug-print-kernel2-variables
383
384 handle_genpatches
385}
386
387kernel_is() {
388 # ALL of these should be set before we can safely continue this function.
389 # some of the sources have in the past had only one set.
390 local v n=0
391 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
392 [[ $n -eq 1 ]] && detect_version
393 unset v n
394
395 # Now we can continue
396 local operator test value x=0 y=0 z=0
397
398 case ${1} in
399 lt) operator="-lt"; shift;;
400 gt) operator="-gt"; shift;;
401 le) operator="-le"; shift;;
402 ge) operator="-ge"; shift;;
403 eq) operator="-eq"; shift;;
404 *) operator="-eq";;
405 esac
406
407 for x in ${@}; do
408 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
409 value="${value}${x}"
410 z=$((${z} + 1))
411
412 case ${z} in
413 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
414 test="${test}${KV_MAJOR}";;
415 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
416 test="${test}${KV_MINOR}";;
417 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
418 test="${test}${KV_PATCH}";;
419 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
420 esac
421 done
422
423 [ ${test} ${operator} ${value} ] && return 0 || return 1
424}
425
55kernel_is_2_4() { 426kernel_is_2_4() {
56 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -eq 4 ] && return 0 || return 1 427 kernel_is 2 4
57} 428}
58 429
59kernel_is_2_6() { 430kernel_is_2_6() {
60 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -eq 5 -o ${KV_MINOR} -eq 6 ] && return 0 || return 1 431 kernel_is 2 6 || kernel_is 2 5
61} 432}
62 433
63# capture the sources type and set depends 434# Capture the sources type and set DEPENDs
64if [ "${ETYPE}" == "sources" ] 435if [[ ${ETYPE} == sources ]]; then
65then
66 #console-tools is needed to solve the loadkeys fiasco; binutils version needed to avoid Athlon/PIII/SSE assembler bugs.
67 DEPEND="!build? ( sys-apps/sed 436 DEPEND="!build? ( sys-apps/sed
68 >=sys-devel/binutils-2.11.90.0.31 )" 437 >=sys-devel/binutils-2.11.90.0.31 )"
69
70 RDEPEND="${DEPEND}
71 !build? ( >=sys-libs/ncurses-5.2 438 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
72 dev-lang/perl
73 sys-apps/module-init-tools
74 sys-devel/make )" 439 sys-devel/make )"
75 440 PDEPEND="!build? ( virtual/dev-manager )"
76 [ $(kernel_is_2_4) $? == 0 ] && PROVIDE="virtual/linux-sources" || PROVIDE="virtual/linux-sources virtual/alsa"
77 441
442 SLOT="${PVR}"
443 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR:-$KV_PATCH} linux kernel"
444 IUSE="symlink build"
445
446 # Bug #266157, deblob for libre support
447 if [[ -z ${K_PREDEBLOBBED} ]] ; then
448 # Bug #359865, force a call to detect_version if needed
449 kernel_is ge 2 6 27 && \
450 [[ -z "${K_DEBLOB_AVAILABLE}" ]] && \
451 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
452 K_DEBLOB_AVAILABLE=1
453 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
454 IUSE="${IUSE} deblob"
455 # Reflect that kernels contain firmware blobs unless otherwise
456 # stripped
457 LICENSE="${LICENSE} !deblob? ( freedist )"
458
459 if [[ -n KV_MINOR ]]; then
460 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
461 else
462 DEBLOB_PV="${KV_MAJOR}.${KV_PATCH}"
463 fi
464
465 if [[ ${KV_MAJOR} -ge 3 ]]; then
466 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}"
467 fi
468
469 DEBLOB_A="deblob-${DEBLOB_PV}"
470 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
471 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
472 DEBLOB_URI_PATH="download/releases/LATEST-${DEBLOB_PV}.N"
473 if ! has "${EAPI:-0}" 0 1 ; then
474 DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
475 else
476 DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
477 fi
478 DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
479 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
480
481 KERNEL_URI="${KERNEL_URI}
482 deblob? (
483 ${DEBLOB_URI}
484 ${DEBLOB_CHECK_URI}
485 )"
486 else
487 # We have no way to deblob older kernels, so just mark them as
488 # tainted with non-libre materials.
489 LICENSE="${LICENSE} freedist"
490 fi
491 fi
492
78elif [ "${ETYPE}" == "headers" ] 493elif [[ ${ETYPE} == headers ]]; then
79then 494 DESCRIPTION="Linux system headers"
80 PROVIDE="virtual/kernel virtual/os-headers" 495
496 # Since we should NOT honour KBUILD_OUTPUT in headers
497 # lets unset it here.
498 unset KBUILD_OUTPUT
499
500 if [[ ${CTARGET} = ${CHOST} ]]; then
501 SLOT="0"
502 else
503 SLOT="${CTARGET}"
504 fi
81else 505else
82 eerror "Unknown ETYPE=\"${ETYPE}\", must be either \"sources\" or \"headers\"" 506 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
83 die 507 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
84fi 508fi
509
510# Cross-compile support functions
511#==============================================================
512kernel_header_destdir() {
513 [[ ${CTARGET} == ${CHOST} ]] \
514 && echo /usr/include \
515 || echo /usr/${CTARGET}/usr/include
516}
517
518cross_pre_c_headers() {
519 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
520}
521
522env_setup_xmakeopts() {
523 # Kernel ARCH != portage ARCH
524 export KARCH=$(tc-arch-kernel)
525
526 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
527 # variables properly or bad things happen !
528 xmakeopts="ARCH=${KARCH}"
529 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
530 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
531 elif type -p ${CHOST}-ar > /dev/null ; then
532 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
533 fi
534 export xmakeopts
535}
85 536
86# Unpack functions 537# Unpack functions
87#============================================================== 538#==============================================================
88unpack_2_4() { 539unpack_2_4() {
89 cd ${S}
90 # this file is required for other things to build properly, 540 # this file is required for other things to build properly,
91 # so we autogenerate it 541 # so we autogenerate it
92 make mrproper || die "make mrproper died" 542 make -s mrproper ${xmakeopts} || die "make mrproper failed"
543 make -s symlinks ${xmakeopts} || die "make symlinks failed"
93 make include/linux/version.h || die "make include/linux/version.h failed" 544 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
94 echo ">>> version.h compiled successfully." 545 echo ">>> version.h compiled successfully."
95} 546}
96 547
548unpack_2_6() {
549 # this file is required for other things to build properly, so we
550 # autogenerate it ... generate a .config to keep version.h build from
551 # spitting out an annoying warning
552 make -s mrproper ${xmakeopts} 2>/dev/null \
553 || die "make mrproper failed"
554
555 # quick fix for bug #132152 which triggers when it cannot include linux
556 # headers (ie, we have not installed it yet)
557 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
558 touch .config
559 eerror "make defconfig failed."
560 eerror "assuming you dont have any headers installed yet and continuing"
561 epause 5
562 fi
563
564 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
565 || die "make include/linux/version.h failed"
566 rm -f .config >/dev/null
567}
568
97universal_unpack() { 569universal_unpack() {
570 debug-print "Inside universal_unpack"
571
572 local oldifs=${IFS}
573 export IFS="."
574 local OKV_ARRAY=( $OKV )
575 export IFS=${oldifs}
576
577 cd "${WORKDIR}"
578 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
579 unpack linux-${KV_MAJOR}.${KV_MINOR}.tar.bz2
580 else
581 unpack linux-${OKV}.tar.bz2
582 fi
583
584 if [[ -d "linux" ]]; then
585 debug-print "Moving linux to linux-${KV_FULL}"
586 mv linux linux-${KV_FULL} \
587 || die "Unable to move source tree to ${KV_FULL}."
588 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
589 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]] &&
590 [[ "${ETYPE}" = "sources" ]]; then
591 debug-print "moving linux-${KV_MAJOR}.${KV_MINOR} to linux-${KV_FULL} "
592 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
593 || die "Unable to move source tree to ${KV_FULL}."
594 else
595 debug-print "moving linux-${OKV} to linux-${KV_FULL} "
596 mv linux-${OKV} linux-${KV_FULL} \
597 || die "Unable to move source tree to ${KV_FULL}."
598 fi
599 elif [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
600 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
601 || die "Unable to move source tree to ${KV_FULL}."
602 fi
603 cd "${S}"
604
98 # remove all backup files 605 # remove all backup files
99 find . -iname "*~" -exec rm {} \; 2> /dev/null 606 find . -iname "*~" -exec rm {} \; 2> /dev/null
100 607
101 if [ -d "${S}/Documentation/DocBook" ] 608 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
609 # only do this for kernel < 2.6.27 since this file does not exist in later
610 # kernels
611 if [[ -n ${KV_MINOR} && ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
102 then 612 then
103 cd ${S}/Documentation/DocBook 613 sed -i \
104 sed -e "s:db2:docbook2:g" Makefile > Makefile.new \ 614 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
105 && mv Makefile.new Makefile 615 "${S}"/arch/ppc/Makefile
106 cd ${S} 616 else
617 sed -i \
618 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
619 "${S}"/arch/powerpc/Makefile
107 fi 620 fi
108} 621}
109 622
110unpack_set_extraversion() { 623unpack_set_extraversion() {
111 # Gentoo Linux uses /boot, so fix 'make install' to work properly and fix EXTRAVERSION
112 cd ${S} 624 cd "${S}"
113 mv Makefile Makefile.orig 625 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
626 cd "${OLDPWD}"
627}
628
629# Should be done after patches have been applied
630# Otherwise patches that modify the same area of Makefile will fail
631unpack_fix_install_path() {
632 cd "${S}"
114 sed -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' \ 633 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
115 -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" \
116 Makefile.orig > Makefile
117 rm Makefile.orig
118} 634}
119 635
120# Compile Functions 636# Compile Functions
121#============================================================== 637#==============================================================
122compile_headers() { 638compile_headers() {
123 local MY_ARCH 639 env_setup_xmakeopts
124 640
125 MY_ARCH=${ARCH} 641 # if we couldnt obtain HOSTCFLAGS from the Makefile,
126 unset ${ARCH} 642 # then set it to something sane
643 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
644 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
645
646 if kernel_is 2 4; then
127 yes "" | make oldconfig 647 yes "" | make oldconfig ${xmakeopts}
128 echo ">>> make oldconfig complete" 648 echo ">>> make oldconfig complete"
129 ARCH=${MY_ARCH} 649 make dep ${xmakeopts}
650 elif kernel_is 2 6; then
651 # 2.6.18 introduces headers_install which means we dont need any
652 # of this crap anymore :D
653 kernel_is ge 2 6 18 && return 0
654
655 # autoconf.h isnt generated unless it already exists. plus, we have
656 # no guarantee that any headers are installed on the system...
657 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
658 || touch include/linux/autoconf.h
659
660 # if K_DEFCONFIG isn't set, force to "defconfig"
661 # needed by mips
662 if [[ -z ${K_DEFCONFIG} ]]; then
663 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
664 case ${CTARGET} in
665 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
666 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
667 *) K_DEFCONFIG="defconfig";;
668 esac
669 else
670 K_DEFCONFIG="defconfig"
671 fi
672 fi
673
674 # if there arent any installed headers, then there also isnt an asm
675 # symlink in /usr/include/, and make defconfig will fail, so we have
676 # to force an include path with $S.
677 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
678 ln -sf asm-${KARCH} "${S}"/include/asm
679 cross_pre_c_headers && return 0
680
681 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
682 if compile_headers_tweak_config ; then
683 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
684 fi
685 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
686 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
687 fi
688}
689
690compile_headers_tweak_config() {
691 # some targets can be very very picky, so let's finesse the
692 # .config based upon any info we may have
693 case ${CTARGET} in
694 sh*)
695 sed -i '/CONFIG_CPU_SH/d' .config
696 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
697 return 0;;
698 esac
699
700 # no changes, so lets do nothing
701 return 1
130} 702}
131 703
132# install functions 704# install functions
133#============================================================== 705#==============================================================
134install_universal() { 706install_universal() {
135 #fix silly permissions in tarball 707 #fix silly permissions in tarball
136 cd ${WORKDIR} 708 cd "${WORKDIR}"
137 chown -R root:root * 709 chown -R root:0 * >& /dev/null
138 chmod -R a+r-w+X,u+w * 710 chmod -R a+r-w+X,u+w *
711 cd ${OLDPWD}
139} 712}
140 713
141install_headers() { 714install_headers() {
142 [ $(kernel_is_2_4) $? == 0 ] && unpack_2_4 715 local ddir=$(kernel_header_destdir)
143 716
144 cd ${S} 717 # 2.6.18 introduces headers_install which means we dont need any
145 dodir /usr/include/linux 718 # of this crap anymore :D
146 ln -sf ${S}/include/asm-${ARCH} ${S}/include/asm 719 if kernel_is ge 2 6 18 ; then
147 cp -ax ${S}/include/linux/* ${D}/usr/include/linux 720 env_setup_xmakeopts
721 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
722
723 # let other packages install some of these headers
724 rm -rf "${D}"/${ddir}/sound #alsa-headers
725 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
726 return 0
727 fi
728
729 # Do not use "linux/*" as that can cause problems with very long
730 # $S values where the cmdline to cp is too long
731 pushd "${S}" >/dev/null
732 dodir ${ddir}/linux
733 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
148 rm -rf ${D}/usr/include/linux/modules 734 rm -rf "${D}"/${ddir}/linux/modules
149 735
150 dodir /usr/include/asm 736 dodir ${ddir}/asm
151 cp -ax ${S}/include/asm/* ${D}/usr/include/asm 737 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
152 738
153 if [ $(kernel_is_2_6) $? == 0 ] 739 if kernel_is 2 6 ; then
154 then 740 dodir ${ddir}/asm-generic
155 dodir /usr/include/asm-generic
156 cp -ax ${S}/include/asm-generic/* ${D}/usr/include/asm-generic 741 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
157 fi 742 fi
743
744 # clean up
745 find "${D}" -name '*.orig' -exec rm -f {} \;
746
747 popd >/dev/null
158} 748}
159 749
160install_sources() { 750install_sources() {
161 local doc
162 local docs
163 local file 751 local file
164 752
165 cd ${S} 753 cd "${S}"
166 dodir /usr/src 754 dodir /usr/src
167 echo ">>> Copying sources..." 755 echo ">>> Copying sources ..."
756
168 file="$(find ${WORKDIR} -iname "docs" -type d)" 757 file="$(find ${WORKDIR} -iname "docs" -type d)"
169 if [ -n "${file}" ] 758 if [[ -n ${file} ]]; then
170 then
171 for file in $(find ${file} -type f) 759 for file in $(find ${file} -type f); do
172 do
173 echo "${file/*docs\//}" >> ${S}/patches.txt 760 echo "${file//*docs\/}" >> "${S}"/patches.txt
174 echo "===================================================" >> ${S}/patches.txt 761 echo "===================================================" >> "${S}"/patches.txt
175 cat ${file} >> ${S}/patches.txt 762 cat ${file} >> "${S}"/patches.txt
176 echo "===================================================" >> ${S}/patches.txt 763 echo "===================================================" >> "${S}"/patches.txt
177 echo "" >> ${S}/patches.txt 764 echo "" >> "${S}"/patches.txt
178 done 765 done
179 fi 766 fi
180 767
181 if [ ! -f ${S}/patches.txt ] 768 if [[ ! -f ${S}/patches.txt ]]; then
182 then
183 # patches.txt is empty so lets use our ChangeLog 769 # patches.txt is empty so lets use our ChangeLog
184 [ -f ${FILESDIR}/../ChangeLog ] && echo "Please check the ebuild ChangeLog for more details." > ${S}/patches.txt 770 [[ -f ${FILESDIR}/../ChangeLog ]] && \
771 echo "Please check the ebuild ChangeLog for more details." \
772 > "${S}"/patches.txt
185 fi 773 fi
186 774
187 for doc in ${UNIPATCH_DOCS}
188 do
189 [ -f ${doc} ] && docs="${docs} ${doc}"
190 done
191
192 if [ -f ${S}/patches.txt ]; then
193 docs="${docs} ${S}/patches.txt"
194 fi
195
196 dodoc ${docs}
197 mv ${WORKDIR}/linux* ${D}/usr/src 775 mv ${WORKDIR}/linux* "${D}"/usr/src
198} 776}
199 777
200# pkg_preinst functions 778# pkg_preinst functions
201#============================================================== 779#==============================================================
202preinst_headers() { 780preinst_headers() {
203 [ -L ${ROOT}usr/include/linux ] && rm ${ROOT}usr/include/linux 781 local ddir=$(kernel_header_destdir)
204 [ -L ${ROOT}usr/include/asm ] && rm ${ROOT}usr/include/asm 782 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
783 [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
205} 784}
206 785
207# pkg_postinst functions 786# pkg_postinst functions
208#============================================================== 787#==============================================================
209postinst_sources() { 788postinst_sources() {
210 if [ ! -h ${ROOT}usr/src/linux ] 789 local MAKELINK=0
211 then 790
791 # if we have USE=symlink, then force K_SYMLINK=1
792 use symlink && K_SYMLINK=1
793
794 # if we're using a deblobbed kernel, it's not supported
795 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
796 use deblob && \
797 K_SECURITY_UNSUPPORTED=deblob
798
799 # if we are to forcably symlink, delete it if it already exists first.
800 if [[ ${K_SYMLINK} > 0 ]]; then
212 ln -sf ${ROOT}usr/src/linux-${KV} ${ROOT}usr/src/linux 801 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
802 MAKELINK=1
803 fi
804
805 # if the link doesnt exist, lets create it
806 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
807
808 if [[ ${MAKELINK} == 1 ]]; then
809 cd "${ROOT}"usr/src
810 ln -sf linux-${KV_FULL} linux
811 cd ${OLDPWD}
213 fi 812 fi
214 813
215 # Don't forget to make directory for sysfs 814 # Don't forget to make directory for sysfs
216 [ ! -d "${ROOT}/sys" -a $(kernel_is_2_6) $? == 0 ] && mkdir /sys 815 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
217 816
218 echo 817 echo
219 einfo "After installing a new kernel of any version, it is important" 818 elog "If you are upgrading from a previous kernel, you may be interested"
220 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y" 819 elog "in the following document:"
221 einfo "created (X.Y is the first 2 parts of your new kernel version)" 820 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
222 echo 821 echo
223 einfo "For example, this kernel will require:" 822
224 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
225 echo
226
227 # if K_EXTRAEINFO is set then lets display it now 823 # if K_EXTRAEINFO is set then lets display it now
228 if [ -n "${K_EXTRAEINFO}" ] 824 if [[ -n ${K_EXTRAEINFO} ]]; then
229 then
230 echo ${K_EXTRAEINFO} | fmt | 825 echo ${K_EXTRAEINFO} | fmt |
231 while read -s ELINE 826 while read -s ELINE; do einfo "${ELINE}"; done
232 do 827 fi
233 einfo "${ELINE}"
234 done
235 828
236 echo 829 # if K_EXTRAELOG is set then lets display it now
830 if [[ -n ${K_EXTRAELOG} ]]; then
831 echo ${K_EXTRAELOG} | fmt |
832 while read -s ELINE; do elog "${ELINE}"; done
237 fi 833 fi
238 834
239 # if K_EXTRAEWARN is set then lets display it now 835 # if K_EXTRAEWARN is set then lets display it now
240 if [ -n "${K_EXTRAEWARN}" ] 836 if [[ -n ${K_EXTRAEWARN} ]]; then
241 then
242 echo ${K_EXTRAEWARN} | fmt | 837 echo ${K_EXTRAEWARN} | fmt |
243 while read -s ELINE 838 while read -s ELINE; do ewarn "${ELINE}"; done
244 do 839 fi
245 ewarn "${ELINE}"
246 done
247 840
841 # optionally display security unsupported message
842 # Start with why
843 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
844 ewarn "Deblobbed kernels are UNSUPPORTED by Gentoo Security."
845 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
846 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
847 fi
848 # And now the general message.
849 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
850 ewarn "This means that it is likely to be vulnerable to recent security issues."
851 ewarn "For specific information on why this kernel is unsupported, please read:"
852 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
853 fi
854
855 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
856 KV_MAJOR=$(get_version_component_range 1 ${OKV})
857 KV_MINOR=$(get_version_component_range 2 ${OKV})
858 KV_PATCH=$(get_version_component_range 3 ${OKV})
859 if [[ "$(tc-arch)" = "sparc" ]]; then
860 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
861 then
248 echo 862 echo
863 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
864 elog "you now need to do"
865 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
866 elog "instead of just"
867 elog " make"
868 elog "to compile the kernel. For more information please browse to"
869 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
870 echo
249 fi 871 fi
250} 872 fi
251
252postinst_headers() {
253 echo
254 einfo "Kernel headers are usually only used when recompiling glibc."
255 einfo "Following the installation of newer headers it is advised that"
256 einfo "you re-merge glibc as follows:"
257 einfo "# emerge glibc"
258 einfo "Failure to do so will cause glibc to not make use of newer"
259 einfo "features present in the updated kernelheaders."
260 echo
261} 873}
262 874
263# pkg_setup functions 875# pkg_setup functions
264#============================================================== 876#==============================================================
265setup_headers() { 877setup_headers() {
266 ARCH=$(uname -m | sed -e s/[i].86/i386/ -e s/x86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/ -e s/amd64/x86_64/)
267 [ "$ARCH" == "sparc" -a "$PROFILE_ARCH" == "sparc64" ] && ARCH="sparc64"
268
269 [ -z "${H_SUPPORTEDARCH}" ] && H_SUPPORTEDARCH="${PN/-*/}" 878 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
270 for i in ${H_SUPPORTEDARCH} 879 for i in ${H_SUPPORTEDARCH}; do
271 do
272 [ "${ARCH}" == "${i}" ] && H_ACCEPT_ARCH="yes" 880 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
273 done 881 done
274 882
275 if [ "${H_ACCEPT_ARCH}" != "yes" ] 883 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
276 then
277 echo 884 echo
278 eerror "This version of ${PN} does not support ${ARCH}." 885 eerror "This version of ${PN} does not support $(tc-arch)."
279 eerror "Please merge the appropriate sources, in most cases" 886 eerror "Please merge the appropriate sources, in most cases"
280 eerror "this will be ${ARCH}-headers." 887 eerror "(but not all) this will be called $(tc-arch)-headers."
281 die "incorrect headers" 888 die "Package unsupported for $(tc-arch)"
282 fi 889 fi
283} 890}
284 891
285# unipatch 892# unipatch
286#============================================================== 893#==============================================================
287unipatch() { 894unipatch() {
288 local i 895 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
289 local x 896 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG
290 local extention 897
291 local PIPE_CMD 898 # set to a standard locale to ensure sorts are ordered properly.
292 local UNIPATCH_DROP 899 myLC_ALL="${LC_ALL}"
293 local KPATCH_DIR 900 myLANG="${LANG}"
294 local PATCH_DEPTH 901 LC_ALL="C"
295 local ELINE 902 LANG=""
296 local STRICT_COUNT
297 903
298 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 904 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
299 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 905 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
906
907 # We're gonna need it when doing patches with a predefined patchlevel
908 eshopts_push -s extglob
300 909
301 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 910 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
302 # usage can be either via an env var or by params 911 # usage can be either via an env var or by params
303 # although due to the nature we pass this within this eclass 912 # although due to the nature we pass this within this eclass
304 # it shall be by param only. 913 # it shall be by param only.
305 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 914 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
306 UNIPATCH_LIST="${@}" 915 UNIPATCH_LIST="${@}"
307 916
308 #unpack any passed tarballs 917 #unpack any passed tarballs
309 for i in ${UNIPATCH_LIST} 918 for i in ${UNIPATCH_LIST}; do
310 do
311 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ] 919 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
312 then
313 extention=${i/*./}
314 case ${extention} in
315 tbz2) PIPE_CMD="tar -xvjf";;
316 bz2) PIPE_CMD="tar -xvjf";;
317 tgz) PIPE_CMD="tar -xvzf";;
318 gz) PIPE_CMD="tar -xvzf";;
319 *) eerror "Unrecognized tarball compression"
320 die "Unrecognized tarball compression";;
321 esac
322
323 if [ -n "${UNIPATCH_STRICTORDER}" ] 920 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
324 then 921 unset z
325 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 922 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
326 mkdir -p ${KPATCH_DIR}/${STRICT_COUNT}/ 923 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
327 ${PIPE_CMD} ${i} -C ${KPATCH_DIR}/${STRICT_COUNT}/ 1>/dev/null 924 do z="${z}0";
925 done
926 PATCH_ORDER="${z}${STRICT_COUNT}"
927
928 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
929 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
930 unpack ${i##*/}
931 popd >/dev/null
328 else 932 else
329 ${PIPE_CMD} ${i} -C ${KPATCH_DIR} 1>/dev/null 933 pushd "${KPATCH_DIR}" >/dev/null
934 unpack ${i##*/}
935 popd >/dev/null
330 fi 936 fi
331 937
332 if [ $? == 0 ] 938 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
333 then
334 einfo "${i/*\//} unpacked"
335 else
336 eerror "Failed to unpack ${i}"
337 die "unable to unpack patch tarball"
338 fi
339 else 939 else
340 extention=${i/*./} 940 extention=${i/*./}
941 extention=${extention/:*/}
341 PIPE_CMD="" 942 PIPE_CMD=""
342 case ${extention} in 943 case ${extention} in
944 xz) PIPE_CMD="xz -dc";;
945 lzma) PIPE_CMD="lzma -dc";;
343 bz2) PIPE_CMD="bzip2 -dc";; 946 bz2) PIPE_CMD="bzip2 -dc";;
344 patch) PIPE_CMD="cat";; 947 patch) PIPE_CMD="cat";;
345 diff) PIPE_CMD="cat";; 948 diff) PIPE_CMD="cat";;
346 gz|Z|z) PIPE_CMD="gzip -dc";; 949 gz|Z|z) PIPE_CMD="gzip -dc";;
347 ZIP|zip) PIPE_CMD="unzip -p";; 950 ZIP|zip) PIPE_CMD="unzip -p";;
348 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i}";; 951 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";;
349 esac 952 esac
953
954 PATCH_LEVEL=${i/*([^:])?(:)}
955 i=${i/:*/}
350 x=${i/*\//} 956 x=${i/*\//}
351 x=${x/\.${extention}/} 957 x=${x/\.${extention}/}
352 958
353 if [ -n "${UNIPATCH_STRICTORDER}" -a -n "${PIPE_CMD}" ] 959 if [ -n "${PIPE_CMD}" ]; then
354 then 960 if [ ! -r "${i}" ]; then
961 echo
962 eerror "FATAL: unable to locate:"
963 eerror "${i}"
964 eerror "for read-only. The file either has incorrect permissions"
965 eerror "or does not exist."
966 die Unable to locate ${i}
967 fi
968
969 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
970 unset z
355 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 971 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
972 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
973 do z="${z}0";
974 done
975 PATCH_ORDER="${z}${STRICT_COUNT}"
976
356 mkdir -p ${KPATCH_DIR}/${STRICT_COUNT}/ 977 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
357 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${STRICT_COUNT}/${x}.patch) 978 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
358 else 979 else
359 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch) 980 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
981 fi
360 fi 982 fi
361 fi 983 fi
362 done 984 done
363 985
364 #populate KPATCH_DIRS so we know where to look to remove the excludes 986 #populate KPATCH_DIRS so we know where to look to remove the excludes
365 x=${KPATCH_DIR} 987 x=${KPATCH_DIR}
366 KPATCH_DIR="" 988 KPATCH_DIR=""
367 for i in $(find ${x} -type d | sort -n) 989 for i in $(find ${x} -type d | sort -n); do
368 do
369 KPATCH_DIR="${KPATCH_DIR} ${i}" 990 KPATCH_DIR="${KPATCH_DIR} ${i}"
370 done 991 done
371 992
993 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
994 # bug #272676
995 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
996 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
997 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
998 echo
999 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
1000 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
1001 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
1002 echo
1003 fi
1004 fi
1005
372 #so now lets get rid of the patchno's we want to exclude 1006 #so now lets get rid of the patchno's we want to exclude
373 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}" 1007 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
374 for i in ${UNIPATCH_DROP} 1008 for i in ${UNIPATCH_DROP}; do
375 do
376 for x in ${KPATCH_DIR}
377 do
378 rm ${x}/${i}* 2>/dev/null
379 if [ $? == 0 ]
380 then
381 einfo "Excluding Patch #${i}" 1009 ebegin "Excluding Patch #${i}"
382 einfo "From: ${x/${WORKDIR}/}" 1010 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
383 fi 1011 eend $?
384 done
385 done 1012 done
386 1013
387 # and now, finally, we patch it :) 1014 # and now, finally, we patch it :)
388 for x in ${KPATCH_DIR} 1015 for x in ${KPATCH_DIR}; do
389 do
390 for i in $(find ${x} -maxdepth 1 -iname "*.patch" -or -iname "*.diff" | sort -n) 1016 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
391 do
392 STDERR_T="${T}/${i/*\//}" 1017 STDERR_T="${T}/${i/*\//}"
393 STDERR_T="${STDERR_T/.patch/.err}" 1018 STDERR_T="${STDERR_T/.patch*/.err}"
394 1019
395 PATCH_DEPTH=0 1020 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
1021 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
1022
1023 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
1024
396 ebegin "Applying ${i/*\//}" 1025 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
397 while [ ${PATCH_DEPTH} -lt 5 ] 1026 while [ ${PATCH_DEPTH} -lt 5 ]; do
398 do
399 echo "Attempting Dry-run:" > ${STDERR_T} 1027 echo "Attempting Dry-run:" >> ${STDERR_T}
400 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T} 1028 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
401 echo "=======================================================" >> ${STDERR_T} 1029 echo "=======================================================" >> ${STDERR_T}
402 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ] 1030 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
403 then
404 echo "Attempting patch:" > ${STDERR_T} 1031 echo "Attempting patch:" > ${STDERR_T}
405 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T} 1032 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
406 echo "=======================================================" >> ${STDERR_T} 1033 echo "=======================================================" >> ${STDERR_T}
407 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ] 1034 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
408 then
409 eend 0 1035 eend 0
410 rm ${STDERR_T} 1036 rm ${STDERR_T}
411 break 1037 break
412 else 1038 else
413 eend 1 1039 eend 1
414 eerror "Failed to apply patch ${i/*\//}" 1040 eerror "Failed to apply patch ${i/*\//}"
415 eerror "Please attach ${STDERR_T} to any bug you may post." 1041 eerror "Please attach ${STDERR_T} to any bug you may post."
1042 eshopts_pop
416 die "Failed to apply ${i/*\//}" 1043 die "Failed to apply ${i/*\//}"
417 fi 1044 fi
418 else 1045 else
419 PATCH_DEPTH=$((${PATCH_DEPTH} + 1)) 1046 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
420 fi 1047 fi
421 done 1048 done
422 if [ ${PATCH_DEPTH} -eq 5 ] 1049 if [ ${PATCH_DEPTH} -eq 5 ]; then
423 then
424 eend 1 1050 eend 1
425 eerror "Please attach ${STDERR_T} to any bug you may post." 1051 eerror "Please attach ${STDERR_T} to any bug you may post."
1052 eshopts_pop
426 die "Unable to dry-run patch." 1053 die "Unable to dry-run patch."
427 fi 1054 fi
428 done 1055 done
429 done 1056 done
430}
431 1057
432# custom functions 1058 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which
1059 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
1060 # which is why I'm not taking too much time over this.
1061 local tmp
1062 for i in ${UNIPATCH_DOCS}; do
1063 tmp="${tmp} ${i//*\/}"
1064 cp -f ${i} "${T}"/
1065 done
1066 UNIPATCH_DOCS="${tmp}"
1067
1068 # clean up KPATCH_DIR's - fixes bug #53610
1069 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
1070
1071 LC_ALL="${myLC_ALL}"
1072 LANG="${myLANG}"
1073 eshopts_pop
1074}
1075
1076# getfilevar accepts 2 vars as follows:
1077# getfilevar <VARIABLE> <CONFIGFILE>
1078# pulled from linux-info
1079
1080getfilevar() {
1081 local workingdir basefname basedname xarch=$(tc-arch-kernel)
1082
1083 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
1084 echo -e "\n"
1085 eerror "getfilevar requires 2 variables, with the second a valid file."
1086 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
1087 else
1088 workingdir=${PWD}
1089 basefname=$(basename ${2})
1090 basedname=$(dirname ${2})
1091 unset ARCH
1092
1093 cd ${basedname}
1094 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
1095 make ${BUILD_FIXES} -s -f - e 2>/dev/null
1096 cd ${workingdir}
1097
1098 ARCH=${xarch}
1099 fi
1100}
1101
1102detect_arch() {
1103 # This function sets ARCH_URI and ARCH_PATCH
1104 # with the neccessary info for the arch sepecific compatibility
1105 # patchsets.
1106
1107 local ALL_ARCH LOOP_ARCH COMPAT_URI i
1108
1109 # COMPAT_URI is the contents of ${ARCH}_URI
1110 # ARCH_URI is the URI for all the ${ARCH}_URI patches
1111 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
1112
1113 ARCH_URI=""
1114 ARCH_PATCH=""
1115 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
1116
1117 for LOOP_ARCH in ${ALL_ARCH}; do
1118 COMPAT_URI="${LOOP_ARCH}_URI"
1119 COMPAT_URI="${!COMPAT_URI}"
1120
1121 [[ -n ${COMPAT_URI} ]] && \
1122 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr '[:upper:]' '[:lower:]')? ( ${COMPAT_URI} )"
1123
1124 if [[ ${LOOP_ARCH} == "$(echo $(tc-arch-kernel) | tr '[:lower:]' '[:upper:]')" ]]; then
1125 for i in ${COMPAT_URI}; do
1126 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}"
1127 done
1128 fi
1129 done
1130}
1131
1132# sparc nastiness
433#============================================================== 1133#==============================================================
434detect_version() { 1134# This script generates the files in /usr/include/asm for sparc systems
435 # this function will detect and set 1135# during installation of sys-kernel/linux-headers.
436 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11) 1136# Will no longer be needed when full 64 bit support is used on sparc64
437 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1) 1137# systems.
438 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1) 1138#
439 1139# Shamefully ripped from Debian
440 OKV=${PV/_beta/-test} 1140# ----------------------------------------------------------------------
441 OKV=${OKV/_rc/-rc} 1141
442 OKV=${OKV/_pre*/} 1142# Idea borrowed from RedHat's kernel package
443 OKV=${OKV/-r*/} 1143
444 1144# This is gonna get replaced by something in multilib.eclass soon...
445 KV_MAJOR=$(echo ${OKV} | cut -d. -f1) 1145# --eradicator
446 KV_MINOR=$(echo ${OKV} | cut -d. -f2) 1146generate_sparc_asm() {
447 KV_PATCH=$(echo ${OKV} | cut -d. -f3) 1147 local name
448 KV_PATCH=${KV_PATCH/[-_]*/} 1148
449 1149 cd $1 || die
450 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 1150 mkdir asm
451 1151
452 RELEASE=${PV/${OKV}/} 1152 for h in `( ls asm-sparc; ls asm-sparc64 ) | grep '\.h$' | sort -u`; do
453 RELEASE=${RELEASE/_beta/} 1153 name="$(echo $h | tr a-z. A-Z_)"
454 RELEASE=${RELEASE/_rc/-rc} 1154 # common header
455 RELEASE=${RELEASE/_pre/-bk} 1155 echo "/* All asm/ files are generated and point to the corresponding
456 RELEASETYPE=${RELEASE//[0-9]/} 1156 * file in asm-sparc or asm-sparc64.
457 1157 */
458 EXTRAVERSION="${RELEASE}" 1158
459 1159#ifndef __SPARCSTUB__${name}__
460 if [ -n "${K_PREPATCHED}" ] 1160#define __SPARCSTUB__${name}__
461 then 1161" > asm/${h}
462 EXTRAVERSION="${EXTRAVERSION}-${PN/-*/}${PR/r/}" 1162
1163 # common for sparc and sparc64
1164 if [ -f asm-sparc/$h -a -f asm-sparc64/$h ]; then
1165 echo "#ifdef __arch64__
1166#include <asm-sparc64/$h>
1167#else
1168#include <asm-sparc/$h>
1169#endif
1170" >> asm/${h}
1171
1172 # sparc only
1173 elif [ -f asm-sparc/$h ]; then
1174echo "#ifndef __arch64__
1175#include <asm-sparc/$h>
1176#endif
1177" >> asm/${h}
1178
1179 # sparc64 only
463 else 1180 else
464 [ -z "${K_NOUSENAME}" ] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*/}" 1181echo "#ifdef __arch64__
465 [ "${PR}" != "r0" ] && EXTRAVERSION="${EXTRAVERSION}-${PR}" 1182#include <asm-sparc64/$h>
1183#endif
1184" >> asm/${h}
466 fi 1185 fi
467
468 KV=${OKV}${EXTRAVERSION}
469
470 # -rcXX-bkXX pulls are *IMPOSSIBLE* to support within the portage naming convention
471 # these cannot be supported, but the code here can handle it up until this point
472 # and theoretically thereafter.
473
474 if [ "${RELEASETYPE}" == "-rc" ]
475 then
476 OKV="${KV_MAJOR}.${KV_MINOR}.$([ $((${KV_PATCH} - 1)) -lt 0 ] && echo ${KV_PATCH} || echo $((${KV_PATCH} - 1)))"
477 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${PV//_/-}.bz2
478 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
479 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${PV//_/-}.bz2"
480 KV=${PV/[-_]*/}${EXTRAVERSION}
481 fi
482
483 if [ "${RELEASETYPE}" == "-bk" ]
484 then
485 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
486 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
487 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
488 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
489 KV=${PV/[-_]*/}${EXTRAVERSION}
490 fi
491
492 if [ "${RELEASETYPE}" == "-rc-bk" ]
493 then
494 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))-${RELEASE/-bk*}"
495 EXTRAVERSION="$([ -n "${RELEASE}" ] && echo ${RELEASE/*-bk/-bk})$([ -n "${K_USENAME}" ] && echo -${PN/-*/})$([ ! "${PR}" == "r0" ] && echo -${PR})"
496
497 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
498 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
499 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
500 KV=${PV/[-_]*/}${EXTRAVERSION}
501 fi
502
503 S=${WORKDIR}/linux-${KV}
504}
505 1186
1187 # common footer
1188 echo "#endif /* !__SPARCSTUB__${name}__ */" >> asm/${h}
1189 done
1190 return 0
1191}
1192
1193headers___fix() {
1194 # Voodoo to partially fix broken upstream headers.
1195 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
1196 sed -i \
1197 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
1198 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
1199 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1200 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1201 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
1202 "$@"
1203}
506 1204
507# common functions 1205# common functions
508#============================================================== 1206#==============================================================
509src_unpack() { 1207kernel-2_src_unpack() {
510 [ -z "${OKV}" ] && OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
511
512 cd ${WORKDIR}
513 unpack linux-${OKV}.tar.bz2
514 if [ "${OKV}" != "${KV}" ]
515 then
516 mv linux-${OKV} linux-${KV} || die "Unable to move source tree to ${KV}."
517 fi
518 cd ${S}
519
520 universal_unpack 1208 universal_unpack
521 [ -n "${UNIPATCH_LIST}" -o -n "${UNIPATCH_LIST_DEFAULT}" ] && unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST}" 1209 debug-print "Doing unipatch"
1210
1211 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
1212 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1213
1214 debug-print "Doing premake"
1215
1216 # allow ebuilds to massage the source tree after patching but before
1217 # we run misc `make` functions below
1218 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1219
1220 debug-print "Doing epatch_user"
1221 epatch_user
1222
1223 debug-print "Doing unpack_set_extraversion"
1224
522 [ -z "${K_NOSETEXTRAVERSION}" ] && unpack_set_extraversion 1225 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
523 [ $(kernel_is_2_4) $? == 0 ] && unpack_2_4 1226 unpack_fix_install_path
524}
525 1227
1228 # Setup xmakeopts and cd into sourcetree.
1229 env_setup_xmakeopts
1230 cd "${S}"
1231
1232 # We dont need a version.h for anything other than headers
1233 # at least, I should hope we dont. If this causes problems
1234 # take out the if/fi block and inform me please.
1235 # unpack_2_6 should now be 2.6.17 safe anyways
1236 if [[ ${ETYPE} == headers ]]; then
1237 kernel_is 2 4 && unpack_2_4
1238 kernel_is 2 6 && unpack_2_6
1239 fi
1240
1241 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1242 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1243 cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1244 chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1245 fi
1246}
1247
526src_compile() { 1248kernel-2_src_compile() {
1249 cd "${S}"
527 [ "${ETYPE}" == "headers" ] && compile_headers 1250 [[ ${ETYPE} == headers ]] && compile_headers
528}
529 1251
1252 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1253 echo ">>> Running deblob script ..."
1254 sh "${T}/${DEBLOB_A}" --force || \
1255 die "Deblob script failed to run!!!"
1256 fi
1257}
1258
1259# if you leave it to the default src_test, it will run make to
1260# find whether test/check targets are present; since "make test"
1261# actually produces a few support files, they are installed even
1262# though the package is binchecks-restricted.
1263#
1264# Avoid this altogether by making the function moot.
1265kernel-2_src_test() { :; }
1266
530pkg_preinst() { 1267kernel-2_pkg_preinst() {
531 [ "${ETYPE}" == "headers" ] && preinst_headers 1268 [[ ${ETYPE} == headers ]] && preinst_headers
532} 1269}
533 1270
534src_install() { 1271kernel-2_src_install() {
535 install_universal 1272 install_universal
536 [ "${ETYPE}" == "headers" ] && install_headers 1273 [[ ${ETYPE} == headers ]] && install_headers
537 [ "${ETYPE}" == "sources" ] && install_sources 1274 [[ ${ETYPE} == sources ]] && install_sources
538} 1275}
539 1276
540pkg_postinst() { 1277kernel-2_pkg_postinst() {
541 [ "${ETYPE}" == "headers" ] && postinst_headers
542 [ "${ETYPE}" == "sources" ] && postinst_sources 1278 [[ ${ETYPE} == sources ]] && postinst_sources
543} 1279}
544 1280
545pkg_setup() { 1281kernel-2_pkg_setup() {
1282 if kernel_is 2 4; then
1283 if [ "$( gcc-major-version )" -eq "4" ] ; then
1284 echo
1285 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1286 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1287 ewarn "newer kernel that supports gcc-4."
1288 echo
1289 ewarn "Also be aware that bugreports about gcc-4 not working"
1290 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1291 echo
1292 epause 10
1293 fi
1294 fi
1295
1296 ABI="${KERNEL_ABI}"
546 [ "${ETYPE}" == "headers" ] && setup_headers 1297 [[ ${ETYPE} == headers ]] && setup_headers
547
548 # this is to fix some weird portage bug? in stable versions of portage.
549 [ "${ETYPE}" == "sources" ] && echo ">>> Preparing to unpack..." 1298 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
550} 1299}
1300
1301kernel-2_pkg_postrm() {
1302 echo
1303 ewarn "Note: Even though you have successfully unmerged "
1304 ewarn "your kernel package, directories in kernel source location: "
1305 ewarn "${ROOT}usr/src/linux-${KV_FULL}"
1306 ewarn "with modified files will remain behind. By design, package managers"
1307 ewarn "will not remove these modified files and the directories they reside in."
1308 echo
1309}
1310

Legend:
Removed from v.1.27  
changed lines
  Added in v.1.260

  ViewVC Help
Powered by ViewVC 1.1.20